#include "CReceiver.hpp"

CReceiver::CReceiver(int nSock,CMutexLock *plsMutexLock)
{
	m_nSock = nSock;
	m_plsMutexLock = plsMutexLock;
}

void* CReceiver::ThreadRun(void *argv)
{
	printf("[%20s:%20s:%5d] [%ld] Recevier Thread Start\n",__FILE__,__func__,__LINE__,GetTid());
	sleep(1);
	ReadMessage();
	printf("[%20s:%20s:%5d] [%ld] Receiver Thread End!!\n",__FILE__,__func__,__LINE__,GetTid());

	return NULL;
}

int CReceiver::ReadMessage()
{
	int nReadLen;

	int nCount = 0;
	time_t tStart,tEnd;
	tStart = time(NULL);
	while (true)
	{
		nReadLen = ReadHeader();
		if(nReadLen == LEN_MSG_HEADER)
		{
			nReadLen = ReadBody();
			if(nReadLen == m_stMsg.nLen)
			{
				nCount++;
				if(nCount>=LOOP_CHECK_COUNT)
				{
					tEnd = time(NULL);
					printf("[%20s:%20s:%3d] [%5ld] nCount[%ld:%d]\n",__FILE__,__func__,__LINE__,GetTid(),(tEnd-tStart),m_stMsg.nMsgID);
					tStart = tEnd;
					nCount=0;
				}
			}
			else
			{
				printf("[%20s:%20s:%3d] [%5ld] rtn[%d:%d]\n",__FILE__,__func__,__LINE__,GetTid(),m_stMsg.nLen,nReadLen);
				return -2;
			}
		}
		else
		{
			if(nReadLen == 0)
			{
				continue;
			}
			printf("[%20s:%20s:%3d] [%5ld] rtn[%d:%d]\n",__FILE__,__func__,__LINE__,GetTid(),LEN_MSG_HEADER,nReadLen);
			return -3;
		}
	}
}

int CReceiver::ReadHeader()
{
	fd_set rfds;
	struct timeval tv;
	int nRtn;

	//m_plsMutexLock->Lock();

	FD_ZERO(&rfds);
	FD_SET(m_nSock, &rfds);

 	/* Wait up to five seconds. */
 	//tv.tv_sec = 40;
 	tv.tv_sec = 1;
 	tv.tv_usec = 0;

	nRtn = select(m_nSock+1, &rfds, NULL, NULL, &tv);
	//m_plsMutexLock->UnLock();
	if(nRtn>0)
	{
        if(FD_ISSET(m_nSock, &rfds))
		{
			time_t tBefore,tAfter;
			int nReadLen = 0;
			tBefore = 0;
			char *ptrData = reinterpret_cast<char*>(&m_stMsg);

			while (true)
			{
				//m_plsMutexLock->Lock();
				nReadLen += recv(m_nSock,ptrData+nReadLen,LEN_MSG_HEADER-nReadLen,0);
				//m_plsMutexLock->UnLock();
				if ( nReadLen >= LEN_MSG_HEADER )
            	{
					return nReadLen;	
            	}
				if(tBefore == 0)
				{
					tBefore = time(NULL);
				}
				tAfter = time(NULL);
				if((tAfter-tBefore) > 3)
				{
            	    printf("[%20s:%20s:%5d] recv error! %d err[%d:%s]\n",__FILE__,__func__,__LINE__,nRtn,errno,strerror(errno)) ;
					return nReadLen;
				}
				usleep(1);
			}
		}
	}
	else
	{
		printf("[%20s:%20s:%5d] select timeout[%d:%d]\n",__FILE__,__func__,__LINE__,nRtn,m_nSock);
	}
	return 0;
}

int CReceiver::ReadBody()
{
	int nReadLen=0;
	time_t tBefore,tAfter;
	
	//tBefore = time(NULL);
	tBefore = 0;
	while(true)
	{
		//m_plsMutexLock->Lock();
		nReadLen += recv(m_nSock,m_stMsg.strData + nReadLen ,m_stMsg.nLen-nReadLen,0);
		//m_plsMutexLock->UnLock();
		if(nReadLen >= m_stMsg.nLen)
		{
			return nReadLen;
		}	
		if(nReadLen < 0)
		{
			return -1;
		}
		if(tBefore == 0)
		{
			tBefore = time(NULL);
		}
		tAfter = time(NULL);
		if((tAfter-tBefore) > 3)
		{
			return nReadLen;
		}
	}

	return nReadLen;
}

