#include "CSender.hpp"

CSender::CSender(int nSock,CMutexLock *plsMutexLock)
{
	m_nSock = nSock ;
	m_plsMutexLock = plsMutexLock;
}

void* CSender::ThreadRun(void *argv)
{
	sleep(2);
	char *ptrData = (char*)"12345678901234567890abcdefghijklmnopqrstuvwxyz1234567890111111111222222222333333333";
	memset((char*)&m_stMsg, 0x00, sizeof(m_stMsg));
	memcpy(m_stMsg.strMsgName,(char*)"abcdefghi",strlen((char*)"abcdefghi"));
	m_stMsg.nLen = strlen(ptrData);
	memcpy(m_stMsg.strData,ptrData,m_stMsg.nLen);
	printf("[%20s:%20s:%5d] [%ld] Sender Thread Start!!\n",__FILE__,__func__,__LINE__,GetTid());
	while(true)
	{
		m_stMsg.nMsgID++;
		SendMessage();
		//usleep(1);
	}
	printf("[%20s:%20s:%5d] [%ld] Sender Thread End!!\n",__FILE__,__func__,__LINE__,GetTid());

	return NULL;
}

int CSender::SendMessage()
{
	int nSendLen = 0;
	int nTotalLen = LEN_MSG_HEADER+m_stMsg.nLen;
	time_t tBefore,tAfter;
	time_t tStart,tEnd;
	char *ptrData = reinterpret_cast<char*>(&m_stMsg);
	
	tBefore = 0;
	tStart = time(NULL);
	while(true)
	{
		//m_plsMutexLock->Lock();
		nSendLen += send(m_nSock,ptrData +nSendLen,nTotalLen -nSendLen,0);
		//m_plsMutexLock->UnLock();
		if(nSendLen >= nTotalLen)
		{
			if((m_stMsg.nMsgID%LOOP_CHECK_COUNT) == 0)
			{
				tEnd = time(NULL);
				printf("[%20s:%20s:%3d] [%5ld] nCount[%ld:%d]\n",__FILE__,__func__,__LINE__,GetTid(),(tEnd-tStart),m_stMsg.nMsgID);
				tStart = tEnd;
			}
			return nSendLen;
		}
		tAfter = time(NULL);
		if(tBefore == 0)
		{
			tBefore = time(NULL);
		}
		if((tAfter-tBefore) > 3)
		{
			return nSendLen;
		}
	}
	return 0;
}

