#include <stdio.h>
#include <fcntl.h>

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netinet/tcp.h>

#include "CReceiver.hpp"
#include "CSender.hpp"

void sigCapture(int nSigNo)
{
	printf("signal no [%d]\n",nSigNo);
	if(nSigNo == 2)
	{
		exit(-1);
	}
}

int main(int argc,char **argv)
{
	static struct sigaction act1, act2;

	act1.sa_handler  = SIG_IGN     ;
	act2.sa_handler  = sigCapture  ;
	sigaction(SIGPIPE, &act1, NULL);
	sigaction(SIGUSR1, &act2, NULL);    // PF&M Stop Command
	sigaction(SIGINT , &act2, NULL);    // Ctrl C
	sigaction(SIGALRM, &act2, NULL);    // alarm clock timeout  //ñ׳ 

    struct sctp_event_subscribe event;
    socklen_t len = sizeof(event);
    struct sockaddr_in serverAddr;
	socklen_t serverAddr_len = sizeof(serverAddr);

    bzero(&serverAddr, sizeof(serverAddr));
    serverAddr.sin_family = AF_INET;
    serverAddr.sin_addr.s_addr = inet_addr(argv[1]);

    serverAddr.sin_port = htons(atoi(argv[2]));
    printf("portString = %d\n", serverAddr.sin_port);


	int nSock = socket(AF_INET, SOCK_STREAM, IPPROTO_SCTP);
	//int nSock = socket(AF_INET, SOCK_STREAM, 0);
	
    memset (&event, 0, sizeof(event));
    if (getsockopt(nSock, IPPROTO_SCTP, SCTP_EVENTS,&event, &len) != 0)
    {
		printf("[%20s:%20s:%5d] getsocketopt Error!!",__FILE__,__func__,__LINE__);
		return -1;
    }

	int nRtn = connect(nSock, (struct sockaddr*) &serverAddr, serverAddr_len);
	if(nRtn != 0)
	{
		printf("[%20s:%20s:%5d] Connect Error[%d]!!",__FILE__,__func__,__LINE__,nRtn);
		return -2;
	}

	if(NON_BLOCK_FLAG)
	{
		int oldflags  ;
		int ret ;
		if ((oldflags = fcntl(nSock,F_GETFL, 0)) < 0 )
		{
			printf("fcntl error\n") ;
		}
		ret  = fcntl(nSock,F_SETFL,oldflags | O_NONBLOCK) ;
	}

/*
	int flag = 1;
	//if(setsockopt(nSock,IPPROTO_TCP,TCP_NODELAY,(char *)&flag,sizeof(flag)) == -1)
	if(setsockopt(nSock,IPPROTO_SCTP,SCTP_NODELAY,(char *)&flag,sizeof(flag)) == -1)
	{
		    return false;
	}
*/
	printf("[%20s:%20s:%5d] Thread Start!![%d\n",__FILE__,__func__,__LINE__,nSock);

	CMutexLock clsMutesLock;
	CSender  clsSender(nSock,&clsMutesLock);
	CReceiver clsReceiver(nSock,&clsMutesLock);

	clsSender.Create();
	clsReceiver.Create();
	//clsSender.Join(NULL);
	clsReceiver.Join(NULL);

	return 0;
}

