#include <stdio.h>
#include <fcntl.h>

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netinet/tcp.h>

#include "CReceiver.hpp"
#include "CSender.hpp"

void sigCapture(int nSigNo)
{
	printf("signal no [%d]\n",nSigNo);
	if(nSigNo == 2)
	{
		exit(-1);
	}
}

int main(int argc,char **argv)
{
	static struct sigaction act1, act2;

	act1.sa_handler  = SIG_IGN     ;
	act2.sa_handler  = sigCapture  ;
	sigaction(SIGPIPE, &act1, NULL);
	sigaction(SIGUSR1, &act2, NULL);    // PF&M Stop Command
	sigaction(SIGINT , &act2, NULL);    // Ctrl C
	sigaction(SIGALRM, &act2, NULL);    // alarm clock timeout  //ñ׳ 

    struct sockaddr_in serverAddr,clientAddr;
	socklen_t serverAddr_len = sizeof(serverAddr);
	socklen_t clientAddr_len = sizeof(serverAddr);

    bzero(&serverAddr, sizeof(serverAddr));
    serverAddr.sin_family = AF_INET;
    serverAddr.sin_addr.s_addr = inet_addr(argv[1]);
    serverAddr.sin_port = htons(atoi(argv[2]));
    printf("portString = %d\n", serverAddr.sin_port);


	int nServerSock = socket(AF_INET, SOCK_STREAM, IPPROTO_SCTP);
	//int nServerSock = socket(AF_INET, SOCK_STREAM, 0);
	int nSock;

    int sopt=1;
    if(setsockopt( nServerSock, SOL_SOCKET, SO_REUSEADDR, &sopt, sizeof(sopt)) < 0)
    {
        int errsv = errno;
        char strError[1024];
        memset(strError, 0x00, sizeof(strError));
        strerror_r(errsv, strError, sizeof(strError) - 1);
        printf("fail to set socket option SOL_SOCKET (%s)", strError);
    }


	bind(nServerSock, (struct sockaddr *)&serverAddr, serverAddr_len);

	listen(nServerSock, 5);

	CReceiver *plsReceiver=NULL;
	CSender   *plsSender  =NULL;

	CMutexLock *plsMutesLock=NULL;

	while (true)
	{
		nSock = accept(nServerSock, (struct sockaddr *)&clientAddr, (socklen_t*)&clientAddr_len);

		if(NON_BLOCK_FLAG)
		{
			int oldflags  ;
			int ret ;
			if ((oldflags = fcntl(nSock,F_GETFL, 0)) < 0 )
			{
				printf("fcntl error\n") ;
				break ;
			}
			ret  = fcntl(nSock,F_SETFL,oldflags | O_NONBLOCK) ;
		}

/*
		int flag = 1;
		//if(setsockopt(nSock,IPPROTO_TCP,TCP_NODELAY,(char *)&flag,sizeof(flag)) == -1)
		if(setsockopt(nSock,IPPROTO_SCTP,SCTP_NODELAY,(char *)&flag,sizeof(flag)) == -1)
		{
			perror("setsocketopt");
			return false;
		}
*/
		printf("[%20s:%20s:%5d] Thread Start!![%d\n",__FILE__,__func__,__LINE__,nSock);

		plsMutesLock = new CMutexLock();
		
		plsSender = new CSender(nSock,plsMutesLock);
		plsSender->Create();
		plsReceiver = new CReceiver(nSock,plsMutesLock);
		plsReceiver->Create();
	}

	return 0;
}
